# $Id$

package Data::Squirrel::Store::DB_File;
use strict;

use DB_File;
use Apache::Session::Store::DB_File;

use vars qw(@ISA);
@ISA=qw(Apache::Session::Store::DB_File);

#########################################################
sub remove
{
    my($self, $squirrel) = @_;

    eval {$self->SUPER::remove($squirrel);};
    warn $@ if $@;
}

#########################################################
sub exists
{
    my($self, $squirrel) = @_;
    
    if (!tied %{$self->{dbm}}) {
        my $rv = tie %{$self->{dbm}}, 'DB_File', $squirrel->{args}{FileName};
        die "Could not open dbm file: $!" unless $rv;
    }
    return defined $self->{dbm}{$squirrel->{data}{_session_id}};
}

#########################################################
sub list_ids
{
    my($self, $squirrel) = @_;
    
    if (!tied %{$self->{dbm}}) {
        my $rv = tie %{$self->{dbm}}, 'DB_File', $squirrel->{args}->{FileName};
        die "Could not open dbm file: $!" unless $rv;
    }
    my @ids=keys %{$self->{dbm}};
    return @ids if wantarray;
    return \@ids;
}


1;

__END__

$Log$
